      !--------------------------------------------------------------------
      subroutine bdfi4r(output,no,start,step,npix,inst,ierr)
      !--------------------------------------------------------------------

      use dal
      use global

      implicit none

      include 'include/cgenl_f90.cmn'

      integer     maxdim,naxis,ix,iy
      parameter   (maxdim=2)
      integer npix(maxdim)
      character(len=1024), intent(in) :: inst
      integer     no, ierr, atype
!     real        exposure 
      double precision start(maxdim),step(maxdim)
      character(len=1024) :: ins1
      character*(*) output

      type(datasett) :: set
      type(arrayt) :: arr
      integer, dimension(:), pointer :: shape
      integer, dimension(:,:), pointer :: i4arr0
      real(kind=single), dimension(:,:), pointer :: r4arr

      set = dataset (output, read)
!      exposure = real32Attribute(set,"EXPOSURE")

      arr = array(set, "PRIMARY", read)
      if (hasAttribute(set,"INSTRUME")) then 
        ins1 = stringAttribute(set,"INSTRUME")
      else if (hasAttribute(arr,"INSTRUME")) then
          ins1 = stringAttribute(arr,"INSTRUME")
      end if 
      if (trim(inst) /= trim(ins1)) &
        call error ("FileMismatch","Exposure map has wrong instrument") 

      shape => dimensions(arr)      
      npix(1) = shape(0)
      npix(2) = shape(1)
      ipa_x = npix(1)
      ipa_y = npix(2)
      idm_x = ipa_x
      idm_y = ipa_y
      allocate (mfeld(ipa_x,ipa_y))
      atype = arrayDataType(arr)

      if (atype == Integer32) then
        i4arr0 => int32array2data(arr)
        do ix=1,npix(1)
          do iy=1,npix(2)
            mfeld(ix,iy) = i4arr0(ix-1,iy-1)
          end do
        end do
      end if
      if (atype == Real32) then
        r4arr => Real32array2data(arr)
        do ix=1,npix(1)
          do iy=1,npix(2)
            mfeld(ix,iy) = r4arr(ix-1,iy-1)
          end do
        end do
      end if
        
      start(1) = 1d0
      start(2) = 1d0
      step(1) = 1d0
      step(2) = 1d0

      call release(arr)
      call release(set)

      end subroutine bdfi4r
