      SUBROUTINE BLIND(IPA,KMERK,X,Y,ISNR,SCTS,ISNRMI,IERR)

!  blinds the exposure map at the position of detected sources

      use global

      implicit none
      include 'include/cgenl.cmn'
      include 'include/cdbio.cmn'
      include 'include/csoio.cmn'
      include 'include/cimsky.cmn'

      integer     i,ierr,ii,ipa,irad,istat,j,jj, 
     &            k,kmerk,nleft,nstart,nfalse
!     integer     npix(2),skycen(2)
      real        epsmin,epsoff,blur,pixsec,radi,rad2,roma, 
     &             x(ipa),y(ipa),cut1
      real        isnr(ipa),scts(ipa),isnrmi,r0,r1,ftest,cutfac
      integer     filtyp,dscival(2),dscdim,im,lench
      integer, dimension(:,:), allocatable :: msave
      character*70  errtext
      character*15  dscnam,dsccval,scm
      character*4   dsctyp
      real        radi_cal
      double precision frac
      integer     tid,acv,kun,knul

      save

      ierr = 0

      allocate(msave(ipa_x,ipa_y))

      nstart=0
      do i=1,ipa_x
        do j=1,ipa_y
          if (mfeld(i,j)>0) nstart=nstart+1
        end do
      end do

      msave = mfeld

      cut1=db_cut
      cutfac=1.0
      nleft=0

! reduce cutout radius if no mask area left after source removal
      do while (float(nleft)/float(nstart)<0.2)
        mfeld = msave

        nfalse=0
! loop to blind sources
        do k = 1,kmerk

! if sufficient snr
          if (isnr(k).ge.isnrmi) then

! circle of radius DB_CUT*BLUR is blinded around source
            pixsec=0.5*(abs(crdelt1)+abs(crdelt2))*3600.0
            epsoff=sqrt((x(k)-skycen(1))**2+ 
     &                  (y(k)-skycen(2))**2)*pixsec

            radi = cutfac * radi_cal (epsoff, scts(k), cut1) / pixsec

            rad2 = radi*radi
            irad = radi+1
            do jj = -irad,irad
              do ii = -irad,irad

! if(distance < rad)
                if((jj*jj+ii*ii).le.rad2)  then

! determine actual pixel
                  j = y(k)+jj+0.5
                  i = x(k)+ii+0.5

! if(pixel inside image)
                  if (i.ge.1 .and. i.le.idm_x .and.
     &                j.ge.1 .and. j.le.idm_y ) then
                    mfeld(i,j) = 0
                    nfalse=nfalse+1
                  endif
                endif
              enddo
            enddo
          endif
        enddo
           
        nleft=0
        do i=1,ipa_x
          do j=1,ipa_y
            if (mfeld(i,j)>0) nleft=nleft+1
          end do
        end do

        cutfac=cutfac*0.95
       
      end do

      deallocate(msave)

      return
      end

