   real function radi_cal (epsoff, scts, cut1) result (r1)

   use cal

   type (PsfT) :: psfp
   
   real, intent(in) :: epsoff, scts, cut1
   real :: r0, ftest, diff
   real(kind=double) :: frac0, frac1, theta  
   integer :: i

   real, parameter :: pi=3.151592654, mm2sec=3600.0*180.0/(pi*7500.0)

   call CAL_setState1(accuracyLevel=ACCURACY_MEDIUM)

   theta = min(epsoff,899.0)
   psfp = CAL_getPSF(2000d0, theta, 0d0)

   r0 = 0.0
   frac0 = 0.0
   diff = 0.9
   do i = 1,20
     frac1 = 1.0-diff
     r1 = CAL_psfEncircledEnergy(psfp,frac1) * mm2sec 
     ftest = scts*(frac1-frac0) / (PI*(r1**2-r0**2))
     if (ftest < cut1) exit
     r0 = r1
     frac0 = frac1
     diff = diff*0.8
   end do 

   return
   end

